"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports.ViewportProvider=void 0;var _react=_interopRequireWildcard(require("react"));var _viewportTypes=_interopRequireWildcard(require("../enums/viewportTypes"));var _capitalizeString=_interopRequireDefault(require("../utils/capitalizeString"));var _checkIfClientSide=_interopRequireDefault(require("../utils/checkIfClientSide"));var _mapServerSideViewportType=_interopRequireDefault(require("../utils/mapServerSideViewportType"));var _findCurrentViewportType=_interopRequireDefault(require("../utils/findCurrentViewportType"));var _mediaWatcher=require("../utils/mediaWatcher");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _getRequireWildcardCache(){if(typeof WeakMap!=="function")return null;var cache=new WeakMap();_getRequireWildcardCache=function _getRequireWildcardCache(){return cache;};return cache;}function _interopRequireWildcard(obj){if(obj&&obj.__esModule){return obj;}if(obj===null||typeof obj!=="object"&&typeof obj!=="function"){return{default:obj};}var cache=_getRequireWildcardCache();if(cache&&cache.has(obj)){return cache.get(obj);}var newObj={};var hasPropertyDescriptor=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var key in obj){if(Object.prototype.hasOwnProperty.call(obj,key)){var desc=hasPropertyDescriptor?Object.getOwnPropertyDescriptor(obj,key):null;if(desc&&(desc.get||desc.set)){Object.defineProperty(newObj,key,desc);}else{newObj[key]=obj[key];}}}newObj.default=obj;if(cache){cache.set(obj,newObj);}return newObj;}function _readOnlyError(name){throw new Error("\""+name+"\" is read-only");}var isClientSide=(0,_checkIfClientSide.default)();var defaultViewportTypes=Object.keys(_viewportTypes.default);var mediaList=mapMediaList();var buildViewportData=function buildViewportData(viewportType){var allViewportTypes=arguments.length>1&&arguments[1]!==undefined?arguments[1]:defaultViewportTypes;var viewportData={viewportType,isPhone:false,isTablet:false,isDesktop:false};for(var i=0;i<allViewportTypes.length;i++){if(allViewportTypes[i]===viewportType){viewportData["is".concat((0,_capitalizeString.default)(viewportType))]=true;return viewportData;}}};var ViewportContext=/*#__PURE__*/(0,_react.createContext)(buildViewportData(_viewportTypes.defaultViewportType));var{Provider}=ViewportContext;var ViewportProvider=(_ref)=>{var{children,customViewportTypes,viewportType}=_ref;if(customViewportTypes){mediaList=(_readOnlyError("mediaList"),mapMediaList(customViewportTypes));}var currentViewportType=isClientSide?(0,_findCurrentViewportType.default)(mediaList):(0,_mapServerSideViewportType.default)({viewportType,mediaList,isCustomMediaList:!!customViewportTypes});var[viewportData,setViewportData]=(0,_react.useState)(buildViewportData(currentViewportType));(0,_react.useEffect)(()=>{var onScreenChange=newViewportType=>{setViewportData(buildViewportData(newViewportType));};(0,_mediaWatcher.subscribeMediaWatcher)({mediaList,mediaListener:onScreenChange});var clientDeviceType=(0,_findCurrentViewportType.default)(mediaList);if(clientDeviceType!==currentViewportType){setDevice(buildDeviceInfo(clientDeviceType));}return _mediaWatcher.unsubscribeMediaWatcher;});return/*#__PURE__*/_react.default.createElement(Provider,{value:viewportData},children);};exports.ViewportProvider=ViewportProvider;ViewportProvider.propTypes={viewportType:PropTypes.string,/** Match media list configuration */customViewportTypes:PropTypes.arrayOf(PropTypes.shape({viewportType:PropTypes.string.isRequired,minWith:PropTypes.number,maxWidth:PropTypes.number})),/** Content to render in the dynamic viewport render */children:PropTypes.func};ViewportProvider.defaultProps={viewportType:undefined,children:null,customViewportTypes:undefined};var _default=ViewportContext;exports.default=_default;